




.intel_syntax noprefix
.text
.p2align 5
.globl fma_mmm_f16_8x8_0_21_6
fma_mmm_f16_8x8_0_21_6:
.cfi_startproc



    push        rbp
    mov         rbp, rsp



    push        rbx
    push        r12
    push        r13
    push        r14
    push        r15

    sub         rsp, 8


.cfi_def_cfa_offset 64

    stmxcsr     [rsp + 4]

    mov         rax, 0x1FC0

    mov         [rsp], eax
    ldmxcsr     [rsp]

// vim: set syntax=asm :

.Lnon_linear:

.Lnon_linear_loop_enter:
    sub     rdi,    40
.Lnon_linear_loop:
    add     rdi,    40
    mov     rax,    [rdi]

    mov     r8, 28
    cmp     rax, 0
    cmovl   rax, r8
    cmp     rax, 28
    cmovg   rax, r8


    lea     r8, [ rip + .Ljmp_table ]

    movsxd  r9, dword ptr [ r8 + rax * 4 ]
    lea     r8, [ r8 + r9 ]
    jmp     r8

.Ljmp_table:

    .long      .Ldone-.Ljmp_table

    .long      .Lclear-.Ljmp_table

    .long      .Lscalar_min-.Ljmp_table

    .long      .Lscalar_max-.Ljmp_table

    .long      .Lscalar_add-.Ljmp_table

    .long      .Lscalar_mul-.Ljmp_table

    .long      .Lscalar_sub-.Ljmp_table

    .long      .Lscalar_sub_flipped-.Ljmp_table

    .long      .Lleaky_relu-.Ljmp_table

    .long      .Lper_row_min-.Ljmp_table

    .long      .Lper_row_max-.Ljmp_table

    .long      .Lper_row_add-.Ljmp_table

    .long      .Lper_row_mul-.Ljmp_table

    .long      .Lper_row_sub-.Ljmp_table

    .long      .Lper_row_sub_flipped-.Ljmp_table

    .long      .Lper_col_min-.Ljmp_table

    .long      .Lper_col_max-.Ljmp_table

    .long      .Lper_col_add-.Ljmp_table

    .long      .Lper_col_mul-.Ljmp_table

    .long      .Lper_col_sub-.Ljmp_table

    .long      .Lper_col_sub_flipped-.Ljmp_table

    .long      .Lq_scale-.Ljmp_table

    .long      .Lq_shr-.Ljmp_table

    .long      .Lq_shl-.Ljmp_table

    .long      .Ladd_unicast-.Ljmp_table

    .long      .Ladd_row_col_products-.Ljmp_table

    .long      .Lstore-.Ljmp_table

    .long      .Ladd_mat_mul-.Ljmp_table

    .long      .Lunsupported-.Ljmp_table

.Lunsupported:
    mov     rax,    1
    jmp     .Lreturn


.Ldone:
    mov     rax, 0
    jmp     .Lreturn




.Lclear:
    vzeroall
    jmp             .Lnon_linear_loop

.Ladd_mat_mul:
    mov     rbx,    [rdi + 24]   // B
    mov     rax,    [rdi + 16]   // A

    mov     rcx,    [rdi + 8]    // k
    test    rcx,    rcx
    jz      .Lnon_linear_loop

.Lmain_loop_packed_packed:
    	// Tile size: 1x8
	// Accumulators: 0-7
	// Col regs: 14 then 8
	// Row regs: 15

    vmovups         xmm15, [rax]
    vmovups         xmm14, [rbx]

    vcvtph2ps       ymm15, xmm15
    vcvtph2ps       ymm14, xmm14

    vbroadcastss    ymm8, xmm14 
    vfmadd231ps     ymm0, ymm15, ymm8

    pshufd          xmm8, xmm14, 1
    vbroadcastss    ymm8, xmm8
    vfmadd231ps     ymm1, ymm15, ymm8

    pshufd          xmm8, xmm14, 2
    vbroadcastss    ymm8, xmm8
    vfmadd231ps     ymm2, ymm15, ymm8

    pshufd          xmm8, xmm14, 3
    vbroadcastss    ymm8, xmm8
    vfmadd231ps     ymm3, ymm15, ymm8

    vperm2f128      ymm14, ymm14, ymm14, 1

    vbroadcastss    ymm8, xmm14 
    vfmadd231ps     ymm4, ymm15, ymm8

    pshufd          xmm8, xmm14, 1
    vbroadcastss    ymm8, xmm8 
    vfmadd231ps     ymm5, ymm15, ymm8

    pshufd          xmm8, xmm14, 2
    vbroadcastss    ymm8, xmm8 
    vfmadd231ps     ymm6, ymm15, ymm8

    pshufd          xmm8, xmm14, 3
    vbroadcastss    ymm8, xmm8
    vfmadd231ps     ymm7, ymm15, ymm8


    add             rax,    16
    add             rbx,    16
    dec             rcx
    jnz             .Lmain_loop_packed_packed

    jmp             .Lnon_linear_loop

// NON LINEAR / ADDC

// vim: set syntax=asm :

// vim: set syntax=asm :

.Lscalar_min:
    
        pinsrw          xmm12, word ptr [rdi + 8], 0
        vcvtph2ps       ymm12, xmm12
        vbroadcastss    ymm12, xmm12
    
    
    
        
            vminps          ymm0, ymm12, ymm0
        
            vminps          ymm1, ymm12, ymm1
        
            vminps          ymm2, ymm12, ymm2
        
            vminps          ymm3, ymm12, ymm3
        
            vminps          ymm4, ymm12, ymm4
        
            vminps          ymm5, ymm12, ymm5
        
            vminps          ymm6, ymm12, ymm6
        
            vminps          ymm7, ymm12, ymm7
        
    

    jmp    .Lnon_linear_loop

// vim: set syntax=asm :

.Lscalar_max:
    
        pinsrw          xmm12, word ptr [rdi + 8], 0
        vcvtph2ps       ymm12, xmm12
        vbroadcastss    ymm12, xmm12
    
    
    
        
            vmaxps          ymm0, ymm12, ymm0
        
            vmaxps          ymm1, ymm12, ymm1
        
            vmaxps          ymm2, ymm12, ymm2
        
            vmaxps          ymm3, ymm12, ymm3
        
            vmaxps          ymm4, ymm12, ymm4
        
            vmaxps          ymm5, ymm12, ymm5
        
            vmaxps          ymm6, ymm12, ymm6
        
            vmaxps          ymm7, ymm12, ymm7
        
    

    jmp    .Lnon_linear_loop

// vim: set syntax=asm :

.Lscalar_add:
    
        pinsrw          xmm12, word ptr [rdi + 8], 0
        vcvtph2ps       ymm12, xmm12
        vbroadcastss    ymm12, xmm12
    
    
    
        
            vaddps          ymm0, ymm12, ymm0
        
            vaddps          ymm1, ymm12, ymm1
        
            vaddps          ymm2, ymm12, ymm2
        
            vaddps          ymm3, ymm12, ymm3
        
            vaddps          ymm4, ymm12, ymm4
        
            vaddps          ymm5, ymm12, ymm5
        
            vaddps          ymm6, ymm12, ymm6
        
            vaddps          ymm7, ymm12, ymm7
        
    

    jmp    .Lnon_linear_loop

// vim: set syntax=asm :

.Lscalar_mul:
    
        pinsrw          xmm12, word ptr [rdi + 8], 0
        vcvtph2ps       ymm12, xmm12
        vbroadcastss    ymm12, xmm12
    
    
    
        
            vmulps          ymm0, ymm12, ymm0
        
            vmulps          ymm1, ymm12, ymm1
        
            vmulps          ymm2, ymm12, ymm2
        
            vmulps          ymm3, ymm12, ymm3
        
            vmulps          ymm4, ymm12, ymm4
        
            vmulps          ymm5, ymm12, ymm5
        
            vmulps          ymm6, ymm12, ymm6
        
            vmulps          ymm7, ymm12, ymm7
        
    

    jmp    .Lnon_linear_loop

// vim: set syntax=asm :

.Lscalar_sub:
    
        pinsrw          xmm12, word ptr [rdi + 8], 0
        vcvtph2ps       ymm12, xmm12
        vbroadcastss    ymm12, xmm12
    
    
    
        
            vsubps          ymm0, ymm12, ymm0
        
            vsubps          ymm1, ymm12, ymm1
        
            vsubps          ymm2, ymm12, ymm2
        
            vsubps          ymm3, ymm12, ymm3
        
            vsubps          ymm4, ymm12, ymm4
        
            vsubps          ymm5, ymm12, ymm5
        
            vsubps          ymm6, ymm12, ymm6
        
            vsubps          ymm7, ymm12, ymm7
        
    

    jmp    .Lnon_linear_loop

// vim: set syntax=asm :

.Lscalar_sub_flipped:
    
        pinsrw          xmm12, word ptr [rdi + 8], 0
        vcvtph2ps       ymm12, xmm12
        vbroadcastss    ymm12, xmm12
    
    
    
        
            vsubps          ymm0, ymm0, ymm12
        
            vsubps          ymm1, ymm1, ymm12
        
            vsubps          ymm2, ymm2, ymm12
        
            vsubps          ymm3, ymm3, ymm12
        
            vsubps          ymm4, ymm4, ymm12
        
            vsubps          ymm5, ymm5, ymm12
        
            vsubps          ymm6, ymm6, ymm12
        
            vsubps          ymm7, ymm7, ymm12
        
    

    jmp    .Lnon_linear_loop


.Lleaky_relu:
    // can only use ymm12 to ymm15
    // ymm15 <- alpha
    
        pinsrw          xmm15, word ptr [rdi + 8], 0
        vcvtph2ps       ymm15, xmm15
        vbroadcastss    ymm15, xmm15
    

    // ymm14 <- all zero
    vpxor           ymm14, ymm14, ymm14

    
        // ymm12 <- alpha * x
        vmulps      ymm12, ymm0, ymm15
        vcmpps     ymm13, ymm14, ymm0, 1 // 1 means LT
        vblendvps   ymm0, ymm12, ymm0, ymm13
    
        // ymm12 <- alpha * x
        vmulps      ymm12, ymm1, ymm15
        vcmpps     ymm13, ymm14, ymm1, 1 // 1 means LT
        vblendvps   ymm1, ymm12, ymm1, ymm13
    
        // ymm12 <- alpha * x
        vmulps      ymm12, ymm2, ymm15
        vcmpps     ymm13, ymm14, ymm2, 1 // 1 means LT
        vblendvps   ymm2, ymm12, ymm2, ymm13
    
        // ymm12 <- alpha * x
        vmulps      ymm12, ymm3, ymm15
        vcmpps     ymm13, ymm14, ymm3, 1 // 1 means LT
        vblendvps   ymm3, ymm12, ymm3, ymm13
    
        // ymm12 <- alpha * x
        vmulps      ymm12, ymm4, ymm15
        vcmpps     ymm13, ymm14, ymm4, 1 // 1 means LT
        vblendvps   ymm4, ymm12, ymm4, ymm13
    
        // ymm12 <- alpha * x
        vmulps      ymm12, ymm5, ymm15
        vcmpps     ymm13, ymm14, ymm5, 1 // 1 means LT
        vblendvps   ymm5, ymm12, ymm5, ymm13
    
        // ymm12 <- alpha * x
        vmulps      ymm12, ymm6, ymm15
        vcmpps     ymm13, ymm14, ymm6, 1 // 1 means LT
        vblendvps   ymm6, ymm12, ymm6, ymm13
    
        // ymm12 <- alpha * x
        vmulps      ymm12, ymm7, ymm15
        vcmpps     ymm13, ymm14, ymm7, 1 // 1 means LT
        vblendvps   ymm7, ymm12, ymm7, ymm13
    
    // select muled of orginal

    jmp    .Lnon_linear_loop

.Lq_scale:
.Lq_shl:
.Lq_shr:
    jmp .Lunsupported


// vim: set syntax=asm :

// vim: set syntax=asm :

.Lper_row_min:
    mov             rax, [ rdi + 8 ]





    
        vmovups         xmm8,  [rax + 0]
    
    
        vcvtph2ps       ymm8, xmm8
    



    
        vminps ymm0, ymm8, ymm0
    
        vminps ymm1, ymm8, ymm1
    
        vminps ymm2, ymm8, ymm2
    
        vminps ymm3, ymm8, ymm3
    
        vminps ymm4, ymm8, ymm4
    
        vminps ymm5, ymm8, ymm5
    
        vminps ymm6, ymm8, ymm6
    
        vminps ymm7, ymm8, ymm7
    


    jmp .Lnon_linear_loop

// vim: set syntax=asm :

.Lper_row_max:
    mov             rax, [ rdi + 8 ]





    
        vmovups         xmm8,  [rax + 0]
    
    
        vcvtph2ps       ymm8, xmm8
    



    
        vmaxps ymm0, ymm8, ymm0
    
        vmaxps ymm1, ymm8, ymm1
    
        vmaxps ymm2, ymm8, ymm2
    
        vmaxps ymm3, ymm8, ymm3
    
        vmaxps ymm4, ymm8, ymm4
    
        vmaxps ymm5, ymm8, ymm5
    
        vmaxps ymm6, ymm8, ymm6
    
        vmaxps ymm7, ymm8, ymm7
    


    jmp .Lnon_linear_loop

// vim: set syntax=asm :

.Lper_row_add:
    mov             rax, [ rdi + 8 ]





    
        vmovups         xmm8,  [rax + 0]
    
    
        vcvtph2ps       ymm8, xmm8
    



    
        vaddps ymm0, ymm8, ymm0
    
        vaddps ymm1, ymm8, ymm1
    
        vaddps ymm2, ymm8, ymm2
    
        vaddps ymm3, ymm8, ymm3
    
        vaddps ymm4, ymm8, ymm4
    
        vaddps ymm5, ymm8, ymm5
    
        vaddps ymm6, ymm8, ymm6
    
        vaddps ymm7, ymm8, ymm7
    


    jmp .Lnon_linear_loop

// vim: set syntax=asm :

.Lper_row_mul:
    mov             rax, [ rdi + 8 ]





    
        vmovups         xmm8,  [rax + 0]
    
    
        vcvtph2ps       ymm8, xmm8
    



    
        vmulps ymm0, ymm8, ymm0
    
        vmulps ymm1, ymm8, ymm1
    
        vmulps ymm2, ymm8, ymm2
    
        vmulps ymm3, ymm8, ymm3
    
        vmulps ymm4, ymm8, ymm4
    
        vmulps ymm5, ymm8, ymm5
    
        vmulps ymm6, ymm8, ymm6
    
        vmulps ymm7, ymm8, ymm7
    


    jmp .Lnon_linear_loop

// vim: set syntax=asm :

.Lper_row_sub:
    mov             rax, [ rdi + 8 ]





    
        vmovups         xmm8,  [rax + 0]
    
    
        vcvtph2ps       ymm8, xmm8
    



    
        vsubps ymm0, ymm8, ymm0
    
        vsubps ymm1, ymm8, ymm1
    
        vsubps ymm2, ymm8, ymm2
    
        vsubps ymm3, ymm8, ymm3
    
        vsubps ymm4, ymm8, ymm4
    
        vsubps ymm5, ymm8, ymm5
    
        vsubps ymm6, ymm8, ymm6
    
        vsubps ymm7, ymm8, ymm7
    


    jmp .Lnon_linear_loop

// vim: set syntax=asm :

.Lper_row_sub_flipped:
    mov             rax, [ rdi + 8 ]





    
        vmovups         xmm8,  [rax + 0]
    
    
        vcvtph2ps       ymm8, xmm8
    



    
        vsubps ymm0, ymm0, ymm8
    
        vsubps ymm1, ymm1, ymm8
    
        vsubps ymm2, ymm2, ymm8
    
        vsubps ymm3, ymm3, ymm8
    
        vsubps ymm4, ymm4, ymm8
    
        vsubps ymm5, ymm5, ymm8
    
        vsubps ymm6, ymm6, ymm8
    
        vsubps ymm7, ymm7, ymm8
    


    jmp .Lnon_linear_loop



// vim: set syntax=asm :

// vim: set syntax=asm :

.Lper_col_min:
    mov             rax, [ rdi + 8 ]











     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vminps ymm0, ymm8, ymm0
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vminps ymm1, ymm8, ymm1
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vminps ymm2, ymm8, ymm2
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vminps ymm3, ymm8, ymm3
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vminps ymm4, ymm8, ymm4
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vminps ymm5, ymm8, ymm5
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vminps ymm6, ymm8, ymm6
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vminps ymm7, ymm8, ymm7
        
    


    jmp .Lnon_linear_loop

// vim: set syntax=asm :

.Lper_col_max:
    mov             rax, [ rdi + 8 ]











     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmaxps ymm0, ymm8, ymm0
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmaxps ymm1, ymm8, ymm1
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmaxps ymm2, ymm8, ymm2
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmaxps ymm3, ymm8, ymm3
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmaxps ymm4, ymm8, ymm4
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmaxps ymm5, ymm8, ymm5
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmaxps ymm6, ymm8, ymm6
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmaxps ymm7, ymm8, ymm7
        
    


    jmp .Lnon_linear_loop

// vim: set syntax=asm :

.Lper_col_add:
    mov             rax, [ rdi + 8 ]











     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vaddps ymm0, ymm8, ymm0
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vaddps ymm1, ymm8, ymm1
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vaddps ymm2, ymm8, ymm2
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vaddps ymm3, ymm8, ymm3
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vaddps ymm4, ymm8, ymm4
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vaddps ymm5, ymm8, ymm5
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vaddps ymm6, ymm8, ymm6
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vaddps ymm7, ymm8, ymm7
        
    


    jmp .Lnon_linear_loop

// vim: set syntax=asm :

.Lper_col_mul:
    mov             rax, [ rdi + 8 ]











     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmulps ymm0, ymm8, ymm0
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmulps ymm1, ymm8, ymm1
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmulps ymm2, ymm8, ymm2
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmulps ymm3, ymm8, ymm3
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmulps ymm4, ymm8, ymm4
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmulps ymm5, ymm8, ymm5
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmulps ymm6, ymm8, ymm6
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vmulps ymm7, ymm8, ymm7
        
    


    jmp .Lnon_linear_loop

// vim: set syntax=asm :

.Lper_col_sub:
    mov             rax, [ rdi + 8 ]











     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm0, ymm8, ymm0
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm1, ymm8, ymm1
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm2, ymm8, ymm2
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm3, ymm8, ymm3
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm4, ymm8, ymm4
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm5, ymm8, ymm5
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm6, ymm8, ymm6
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm7, ymm8, ymm7
        
    


    jmp .Lnon_linear_loop

// vim: set syntax=asm :

.Lper_col_sub_flipped:
    mov             rax, [ rdi + 8 ]











     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm0, ymm0, ymm8
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm1, ymm1, ymm8
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm2, ymm2, ymm8
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm3, ymm3, ymm8
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm4, ymm4, ymm8
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm5, ymm5, ymm8
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm6, ymm6, ymm8
        
    

     
        pinsrw          xmm8, word ptr [ rax ], 0
        add             rax, 2
        vcvtph2ps      ymm8, xmm8
        vbroadcastss    ymm8, xmm8
    
    
        
        
            vsubps ymm7, ymm7, ymm8
        
    


    jmp .Lnon_linear_loop




.Ladd_unicast:
    mov     r8,     [rdi + 8]           // c ptr
    mov     rsi,    [rdi + 16]          // row stride
    mov     rdx,    [rdi + 24]          // col stride

    
        mov r10, r8
        
            pinsrw      xmm8, word ptr [r10], 0
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 1
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 2
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 3
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 4
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 5
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 6
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 7
            add         r10, rsi
        
        vcvtph2ps ymm8, xmm8
        vaddps    ymm0, ymm0, ymm8
        add r8, rdx
    
        mov r10, r8
        
            pinsrw      xmm8, word ptr [r10], 0
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 1
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 2
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 3
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 4
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 5
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 6
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 7
            add         r10, rsi
        
        vcvtph2ps ymm8, xmm8
        vaddps    ymm1, ymm1, ymm8
        add r8, rdx
    
        mov r10, r8
        
            pinsrw      xmm8, word ptr [r10], 0
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 1
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 2
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 3
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 4
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 5
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 6
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 7
            add         r10, rsi
        
        vcvtph2ps ymm8, xmm8
        vaddps    ymm2, ymm2, ymm8
        add r8, rdx
    
        mov r10, r8
        
            pinsrw      xmm8, word ptr [r10], 0
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 1
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 2
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 3
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 4
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 5
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 6
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 7
            add         r10, rsi
        
        vcvtph2ps ymm8, xmm8
        vaddps    ymm3, ymm3, ymm8
        add r8, rdx
    
        mov r10, r8
        
            pinsrw      xmm8, word ptr [r10], 0
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 1
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 2
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 3
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 4
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 5
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 6
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 7
            add         r10, rsi
        
        vcvtph2ps ymm8, xmm8
        vaddps    ymm4, ymm4, ymm8
        add r8, rdx
    
        mov r10, r8
        
            pinsrw      xmm8, word ptr [r10], 0
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 1
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 2
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 3
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 4
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 5
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 6
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 7
            add         r10, rsi
        
        vcvtph2ps ymm8, xmm8
        vaddps    ymm5, ymm5, ymm8
        add r8, rdx
    
        mov r10, r8
        
            pinsrw      xmm8, word ptr [r10], 0
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 1
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 2
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 3
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 4
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 5
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 6
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 7
            add         r10, rsi
        
        vcvtph2ps ymm8, xmm8
        vaddps    ymm6, ymm6, ymm8
        add r8, rdx
    
        mov r10, r8
        
            pinsrw      xmm8, word ptr [r10], 0
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 1
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 2
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 3
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 4
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 5
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 6
            add         r10, rsi
        
            pinsrw      xmm8, word ptr [r10], 7
            add         r10, rsi
        
        vcvtph2ps ymm8, xmm8
        vaddps    ymm7, ymm7, ymm8
        add r8, rdx
    

    jmp    .Lnon_linear_loop

.Ladd_row_col_products:
    mov             rax, [ rdi + 8 ]
    mov             rbx, [ rdi + 16 ]

    vmovups         xmm12, [rax]
    vcvtph2ps       ymm12, xmm12


    pinsrw          xmm14, word ptr [rbx + 0 ], 0
    vcvtph2ps       ymm14, xmm14
    vbroadcastss    ymm14, xmm14
    vfmadd231ps     ymm0, ymm12, ymm14

    pinsrw          xmm14, word ptr [rbx + 2 ], 0
    vcvtph2ps       ymm14, xmm14
    vbroadcastss    ymm14, xmm14
    vfmadd231ps     ymm1, ymm12, ymm14

    pinsrw          xmm14, word ptr [rbx + 4 ], 0
    vcvtph2ps       ymm14, xmm14
    vbroadcastss    ymm14, xmm14
    vfmadd231ps     ymm2, ymm12, ymm14

    pinsrw          xmm14, word ptr [rbx + 6 ], 0
    vcvtph2ps       ymm14, xmm14
    vbroadcastss    ymm14, xmm14
    vfmadd231ps     ymm3, ymm12, ymm14

    pinsrw          xmm14, word ptr [rbx + 8 ], 0
    vcvtph2ps       ymm14, xmm14
    vbroadcastss    ymm14, xmm14
    vfmadd231ps     ymm4, ymm12, ymm14

    pinsrw          xmm14, word ptr [rbx + 10 ], 0
    vcvtph2ps       ymm14, xmm14
    vbroadcastss    ymm14, xmm14
    vfmadd231ps     ymm5, ymm12, ymm14

    pinsrw          xmm14, word ptr [rbx + 12 ], 0
    vcvtph2ps       ymm14, xmm14
    vbroadcastss    ymm14, xmm14
    vfmadd231ps     ymm6, ymm12, ymm14

    pinsrw          xmm14, word ptr [rbx + 14 ], 0
    vcvtph2ps       ymm14, xmm14
    vbroadcastss    ymm14, xmm14
    vfmadd231ps     ymm7, ymm12, ymm14

    jmp    .Lnon_linear_loop

.Lstore:
    mov     r8,     [rdi + 8]           // c ptr
    mov     rsi,    [rdi + 16]          // row stride
    mov     rdx,    [rdi + 24]          // col stride

    
        mov r10, r8
        vcvtps2ph xmm8, ymm0, 0
        
            pextrw      word ptr [r10], xmm8, 0
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 1
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 2
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 3
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 4
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 5
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 6
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 7
            add         r10, rsi
        
        add r8, rdx
    
        mov r10, r8
        vcvtps2ph xmm8, ymm1, 0
        
            pextrw      word ptr [r10], xmm8, 0
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 1
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 2
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 3
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 4
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 5
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 6
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 7
            add         r10, rsi
        
        add r8, rdx
    
        mov r10, r8
        vcvtps2ph xmm8, ymm2, 0
        
            pextrw      word ptr [r10], xmm8, 0
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 1
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 2
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 3
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 4
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 5
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 6
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 7
            add         r10, rsi
        
        add r8, rdx
    
        mov r10, r8
        vcvtps2ph xmm8, ymm3, 0
        
            pextrw      word ptr [r10], xmm8, 0
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 1
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 2
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 3
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 4
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 5
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 6
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 7
            add         r10, rsi
        
        add r8, rdx
    
        mov r10, r8
        vcvtps2ph xmm8, ymm4, 0
        
            pextrw      word ptr [r10], xmm8, 0
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 1
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 2
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 3
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 4
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 5
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 6
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 7
            add         r10, rsi
        
        add r8, rdx
    
        mov r10, r8
        vcvtps2ph xmm8, ymm5, 0
        
            pextrw      word ptr [r10], xmm8, 0
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 1
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 2
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 3
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 4
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 5
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 6
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 7
            add         r10, rsi
        
        add r8, rdx
    
        mov r10, r8
        vcvtps2ph xmm8, ymm6, 0
        
            pextrw      word ptr [r10], xmm8, 0
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 1
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 2
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 3
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 4
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 5
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 6
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 7
            add         r10, rsi
        
        add r8, rdx
    
        mov r10, r8
        vcvtps2ph xmm8, ymm7, 0
        
            pextrw      word ptr [r10], xmm8, 0
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 1
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 2
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 3
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 4
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 5
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 6
            add         r10, rsi
        
            pextrw      word ptr [r10], xmm8, 7
            add         r10, rsi
        
        add r8, rdx
    

    jmp     .Lnon_linear_loop


.Lreturn:
    ldmxcsr     [rsp + 4]
    add         rsp, 8

    pop r15
    pop r14
    pop r13
    pop r12
    pop rbx



    mov rsp, rbp
    pop rbp
    ret


.cfi_endproc


